<?php

function mh_customize_register($wp_customize) {

	/***** Register Custom Controls *****/

	class MH_Corporate_Basic_Upgrade extends WP_Customize_Control {
        public function render_content() {  ?>
        	<p class="mh-upgrade-thumb">
        		<img src="<?php echo get_template_directory_uri(); ?>/images/mh_corporate.png" />
        	</p>
        	<p class="customize-control-title mh-upgrade-title">
        		<?php esc_html_e('MH Corporate Pro', 'mh-corporate-basic'); ?>
        	</p>
        	<p class="textfield mh-upgrade-text">
        		<?php esc_html_e('If you like the free version of this theme, you will LOVE the full version of MH Corporate which includes unique custom widgets, additional features and more useful options to customize your website.', 'mh-corporate-basic'); ?>
			</p>
			<p class="customize-control-title mh-upgrade-title">
        		<?php esc_html_e('Additional Features:', 'mh-corporate-basic'); ?>
        	</p>
        	<ul class="mh-upgrade-features">
	        	<li class="mh-upgrade-feature-item">
	        		<?php esc_html_e('Options to modify color scheme', 'mh-corporate-basic'); ?>
	        	</li>
	        	<li class="mh-upgrade-feature-item">
	        		<?php esc_html_e('Typography options', 'mh-corporate-basic'); ?>
	        	</li>
	        	<li class="mh-upgrade-feature-item">
	        		<?php esc_html_e('Several additional widget areas', 'mh-corporate-basic'); ?>
	        	</li>
	        	<li class="mh-upgrade-feature-item">
	        		<?php esc_html_e('Additional custom widgets', 'mh-corporate-basic'); ?>
	        	</li>
	        	<li class="mh-upgrade-feature-item">
	        		<?php esc_html_e('Social buttons, related articles, and more...', 'mh-corporate-basic'); ?>
	        	</li>
        	</ul>
			<p class="mh-button mh-upgrade-button">
				<a href="https://www.mhthemes.com/themes/mh/corporate/" target="_blank" class="button button-secondary">
					<?php esc_html_e('Upgrade to MH Corporate Pro', 'mh-corporate-basic'); ?>
				</a>
			</p>
			<p class="mh-button">
				<a href="https://www.mhthemes.com/themes/showcase/" target="_blank" class="button button-secondary">
					<?php esc_html_e('MH Themes Showcase', 'mh-corporate-basic'); ?>
				</a>
			</p>
			<p class="mh-button">
				<a href="https://www.mhthemes.com/support/documentation-mh-corporate/" target="_blank" class="button button-secondary">
					<?php esc_html_e('Theme Documentation', 'mh-corporate-basic'); ?>
				</a>
			</p>
			<p class="mh-button">
				<a href="https://wordpress.org/support/theme/mh-corporate-basic" target="_blank" class="button button-secondary">
					<?php esc_html_e('Support Forum', 'mh-corporate-basic'); ?>
				</a>
			</p><?php
        }
    }

    /***** Add Panels *****/

	$wp_customize->add_panel('mh_theme_options', array('title' => esc_html__('Theme Options', 'mh-corporate-basic'), 'description' => '', 'capability' => 'edit_theme_options', 'theme_supports' => '', 'priority' => 1));

	/***** Add Sections *****/

	$wp_customize->add_section('mh_corporate_basic_general', array('title' => esc_html__('General', 'mh-corporate-basic'), 'priority' => 1, 'panel' => 'mh_theme_options'));
	$wp_customize->add_section('mh_corporate_basic_upgrade', array('title' => esc_html__('More Features', 'mh-corporate-basic'), 'priority' => 2, 'panel' => 'mh_theme_options'));

    /***** Add Settings *****/

    $wp_customize->add_setting('mhc_options[excerpt_length]', array('default' => 300, 'type' => 'option', 'sanitize_callback' => 'mh_sanitize_integer'));
    $wp_customize->add_setting('mhc_options[excerpt_more]', array('default' => '[...]', 'type' => 'option', 'sanitize_callback' => 'mh_sanitize_text'));
    $wp_customize->add_setting('mhc_options[sb_position]', array('default' => 'right', 'type' => 'option', 'sanitize_callback' => 'mh_sanitize_select'));
    $wp_customize->add_setting('mhc_options[full_bg]', array('default' => '', 'type' => 'option', 'sanitize_callback' => 'mh_sanitize_checkbox'));
	$wp_customize->add_setting('mhc_options[premium_version_upgrade]', array('default' => '', 'type' => 'option', 'sanitize_callback' => 'esc_attr'));

    /***** Add Controls *****/

    $wp_customize->add_control('excerpt_length', array('label' => esc_html__('Custom Excerpt Length in Characters', 'mh-corporate-basic'), 'section' => 'mh_corporate_basic_general', 'settings' => 'mhc_options[excerpt_length]', 'priority' => 1, 'type' => 'text'));
    $wp_customize->add_control('excerpt_more', array('label' => esc_html__('Custom Excerpt More-Text', 'mh-corporate-basic'), 'section' => 'mh_corporate_basic_general', 'settings' => 'mhc_options[excerpt_more]', 'priority' => 2, 'type' => 'text'));
    $wp_customize->add_control('sb_position', array('label' => esc_html__('Position of Sidebar', 'mh-corporate-basic'), 'section' => 'mh_corporate_basic_general', 'settings' => 'mhc_options[sb_position]', 'priority' => 3, 'type' => 'select', 'choices' => array('left' => esc_html__('Left', 'mh-corporate-basic'), 'right' => esc_html__('Right', 'mh-corporate-basic'))));
	$wp_customize->add_control('full_bg', array('label' => esc_html__('Scale Background Image to Full Size', 'mh-corporate-basic'), 'section' => 'background_image', 'settings' => 'mhc_options[full_bg]', 'priority' => 99, 'type' => 'checkbox'));
	$wp_customize->add_control(new MH_Corporate_Basic_Upgrade($wp_customize, 'premium_version_upgrade', array('section' => 'mh_corporate_basic_upgrade', 'settings' => 'mhc_options[premium_version_upgrade]', 'priority' => 1)));
}
add_action('customize_register', 'mh_customize_register');

/***** Data Sanitization *****/

function mh_sanitize_text($input) {
    return wp_kses_post(force_balance_tags($input));
}
function mh_sanitize_integer($input) {
    return strip_tags(intval($input));
}
function mh_sanitize_checkbox($input) {
    if ($input == 1) {
        return 1;
    } else {
        return '';
    }
}
function mh_sanitize_select($input) {
    $valid = array(
        'left' => esc_html__('Left', 'mh-corporate-basic'),
        'right' => esc_html__('Right', 'mh-corporate-basic')
    );
    if (array_key_exists($input, $valid)) {
        return $input;
    } else {
        return '';
    }
}

/***** Return Theme Options / Set Default Options *****/

if (!function_exists('mh_theme_options')) {
	function mh_theme_options() {
		$theme_options = wp_parse_args(
			get_option('mhc_options', array()),
			mh_theme_default_options()
		);
		return $theme_options;
	}
}

if (!function_exists('mh_theme_default_options')) {
	function mh_theme_default_options() {
		$default_options = array(
			'excerpt_length' => 175,
			'excerpt_more' => '[...]',
			'sb_position' => 'right',
			'full_bg' => ''
		);
		return $default_options;
	}
}

/***** Enqueue Customizer CSS *****/

function mh_corporate_basic_customizer_css() {
	wp_enqueue_style('mh-customizer', get_template_directory_uri() . '/admin/customizer.css', array());
}
add_action('customize_controls_print_styles', 'mh_corporate_basic_customizer_css');

?>